/*
 * SPDX-FileCopyrightText: NVIDIA CORPORATION & AFFILIATES
 * Copyright (c) 2023-2025 NVIDIA CORPORATION & AFFILIATES. All rights reserved.
 * SPDX-License-Identifier: LicenseRef-NvidiaProprietary
 *
 * NVIDIA CORPORATION, its affiliates and licensors retain all intellectual
 * property and proprietary rights in and to this material, related
 * documentation and any modifications thereto. Any use, reproduction,
 * disclosure or distribution of this material and related documentation
 * without an express license agreement from NVIDIA CORPORATION or
 * its affiliates is strictly prohibited.
 */

#ifndef DOCA_MIRROR_H
#define DOCA_MIRROR_H

#define DOCA_MIRRORS_MAX_TARGETS 16

struct doca_mirror_ctx;
struct doca_mirrors;
struct netdev;

struct doca_mirrors *
doca_mirrors_create(uint32_t esw_id, struct netdev *netdev);
void
doca_mirrors_destroy(struct doca_mirrors *doca_mirrors);

struct doca_mirror_ctx *
doca_mirror_ctx_ref(struct doca_mirrors *doca_mirrors,
                    struct doca_flow_resource_mirror_cfg *cfg);
void
doca_mirror_ctx_unref(struct doca_mirror_ctx *mirror_ctx);

int
doca_mirror_ctx_get_id(struct doca_mirror_ctx *mirror_ctx, uint32_t *id);

#endif /* DOCA_MIRROR_H */
